--[[ Notes: 
	1) To use OnUpdate functionalty you'll need to uncomment this and the function RepTracker_OnUpdate

	2) C_Timer.After(seconds, function() <Your function1() function2() end) can also be used like
		C_Timer.After(seconds, function1) without the () in the function

	3) "local standingId, _, topValue, earnedValue = select(3, GetFactionInfo(StormwindRepID))" 
		where 3 starts at the third variable in the table

	4) This is an example of the full code from GetFactionInfo()
	"local name, description, standingId, bottomValue, topValue, earnedValue, atWarWith, canToggleAtWar, isHeader isCollapsed, hasRep, isWatched, isChild, factionID = GetFactionInfo(a)"

	5) Preserved here just in case I need to use it later.
	"local factionID1 = select(6,GetWatchedFactionInfo())" 

	6) Known Bugs: In AV the rep for IF/Org isn't displayed correctly
					Zones with multiple reps aren't displaying correctly.
					
					Exiting the Deeprun Tram trigger double swap notifications
	
	To-do:
	
	Recode the chatframe functionality to always display the correct rep.
	]]--

	local addon_name, addon_data = ...
	local FactionIsHorde
	local FactionIsAlliance
	
	local core_frame = CreateFrame("Frame", addon_name .. "CoreFrame", UIParent)
	core_frame:RegisterEvent("ADDON_LOADED")
	core_frame:SetScript("OnUpdate", CoreFrame_OnUpdate)
	
	local function OnAddonLoaded(self)
		core_frame:RegisterEvent("CHAT_MSG_COMBAT_FACTION_CHANGE")
		core_frame:RegisterEvent("PLAYER_ENTERING_WORLD")
		core_frame:RegisterEvent("UPDATE_FACTION")
		core_frame:RegisterEvent("ZONE_CHANGED")
		core_frame:RegisterEvent("ZONE_CHANGED_INDOORS")
		core_frame:RegisterEvent("ZONE_CHANGED_NEW_AREA")
		core_frame:RegisterEvent("UPDATE_INSTANCE_INFO")
			--Used to determine the players faction.
		if UnitRace("player") == REPTRACKER_HUMAN or UnitRace("player") == REPTRACKER_NIGHTELF or UnitRace("player") == REPTRACKER_GNOME or UnitRace("player") == REPTRACKER_DWARF then
			print("Faction is Alliance")
			FactionIsAlliance = 1
		else
			print("Faction is Horde")
			FactionIsHorde = 1
		end
	end
	
--	local function CoreFrame_OnUpdate()
--	end
	
	local function CoreFrame_OnEvent(self, event, ...)
		local args = {...}
	
	   if event == "ADDON_LOADED" then
			if args[1] == "RepTracker" then
				OnAddonLoaded()
			end
		end
	
		if event == "PLAYER_ENTERING_WORLD" then
			C_Timer.After(20,ZoneInstanceData)
		end
	
		if event == "UPDATE_FACTION" then
			--GrabCurrentFactionValues()
			--ZoneInstanceData()
		end
		if event == "ZONE_CHANGED" then
			C_Timer.After(5,ZoneInstanceData)
		end
		if event == "UPDATE_INSTANCE_INFO" then
			C_Timer.After(5,ZoneInstanceData)
		end
		if event == "ZONE_CHANGED_INDOORS" then
			C_Timer.After(5,ZoneInstanceData)
		end
		if event == "ZONE_CHANGED_NEW_AREA" then
			isPlayerInBattleground()
		end
		if event == "CHAT_MSG_COMBAT_FACTION_CHANGE" then
			if UnitOnTaxi("player") == false then
			
				ZoneInstanceData()
				
				local CurrentZone = GetRealZoneText()
				local SubZone = GetSubZoneText()
				
				--MAJOR CITIES
				if CurrentZone == REPTRACKER_IRONFORGE then
					if FactionIsAlliance then
						print(FactionIsAlliance)
						if SubZone == REPTRACKER_TINKERTOWN then
							local a = GnomereganExilesRepId
							RepTracker_RepValue_Display(a)
						elseif SubZone == REPTRACKER_HALLOFARMS then
						else
							local a = IronforgeRepID
							RepTracker_RepValue_Display(a)
						end
					end
				end
				if CurrentZone == REPTRACKER_DARNASSUS then
					if FactionIsAlliance then
						print(FactionIsAlliance)
						local a = DarnassusRepID
						RepTracker_RepValue_Display(a)
					end
				end
				if CurrentZone == REPTRACKER_STORMWINDCITY then
					if FactionIsAlliance then
						print(FactionIsAlliance)
						if SubZone == REPTRACKER_STORMWINDKEEP then
						else
							local a = StormwindRepID
							RepTracker_RepValue_Display(a)
						end
					end
				end
				if CurrentZone == REPTRACKER_ORGRIMMAR then
					if FactionIsHorde then
						print(FactionIsHorde)
						local a = OgrimmarRepID
						RepTracker_RepValue_Display(a)
					end
				end
				if CurrentZone == REPTRACKER_UNDERCITY then
					if FactionIsHorde then
						print(FactionIsHorde)
						local a = UndercityRepID
						RepTracker_RepValue_Display(a)
					end
				end
				if CurrentZone == REPTRACKER_THUNDERBLUFF then
					print(FactionIsHorde)
					if FactionIsHorde then
						local a = ThunderBluffRepID
						RepTracker_RepValue_Display(a)
					end
				end
				
				--RAID REPUTATIONS
				if CurrentZone == REPTRACKER_ANHQIRAJ then
					local a = BroodofNozdormuRepID
					RepTracker_RepValue_Display(a)
				end
				if CurrentZone == REPTRACKER_RUINSOFAHNQIRAJ or CurrentZone == REPTRACKER_MOONGLADE or CurrentZone == REPTRACKER_SILITHUS then
					local a = CenarionCircleRepID
					RepTracker_RepValue_Display(a)
				end
				if CurrentZone == REPTRACKER_STRANGLETHORNVALE then
					if SubZone == REPTRACKER_YOJAMBAISLE then
						local a = ZandalarTribeRepID
						RepTracker_RepValue_Display(a)
					end
				end
				if CurrentZone == REPTRACKER_ZULGURUB then
					local a = ZandalarTribeRepID
					RepTracker_RepValue_Display(a)
				end
				if CurrentZone == REPTRACKER_SCHOLOMANCE or CurrentZone == REPTRACKER_STRATHOLME then
					local a = ArgentDawnRepID
					RepTracker_RepValue_Display(a)
				end
				if CurrentZone == REPTRACKER_MOLTENCORE then
					local a = HydraxianWaterlordsRepID
					RepTracker_RepValue_Display(a)
				end
				
				--WORLD REPUTATIONS
				if CurrentZone == REPTRACKER_WINTERSPRING or CurrentZone == REPTRACKER_FELWOOD then
					local TimbermawHoldRepID
					RepTracker_RepValue_Display(a)
				end
				if CurrentZone == REPTRACKER_SEARINGGORGE then
					local a = ThoriumBrotherhoodRepID
					RepTracker_RepValue_Display(a)
				end
				
				--PVP REPUTATION ZONES
				if CurrentZone == REPTRACKER_ALTERACVALLEY then
					if FactionIsHorde then
						local a = FrostwolfClanRepID
						RepTracker_RepValue_Display(a)
					else
						local a = StormpikeGuardRepID
						RepTracker_RepValue_Display(a)
					end
				end
				if CurrentZone == REPTRACKER_ARATHIBASIN then
					if FactionIsHorde then
						local a = TheDefilersRepID
						RepTracker_RepValue_Display(a)
					else
						local a = TheLeagueOfArathorRepID
						RepTracker_RepValue_Display(a)
					end
				end
				if CurrentZone == REPTRACKER_WARSONGGULCH then
					if FactionIsHorde then
						local a = WarsongOutridersRepID
						RepTracker_RepValue_Display(a)
					else
						local a = SilverwingSentinelsRepID
						RepTracker_RepValue_Display(a)
					end
				end
				if CurrentZone == REPTRACKER_ARATHIHIGHLANDS then
					if SubZone == REPTRACKER_REFUGEPOINTE then
						local a = TheLeagueOfArathorRepID
						RepTracker_RepValue_Display(a)
					end
				end
				if CurrentZone == REPTRACKER_ASHENVALE then
					if SubZone == REPTRACKER_SILVERWINGGROVE then
						local a = SilverwingSentinelsRepID
						RepTracker_RepValue_Display(a)
					end
				end
				if CurrentZone == REPTRACKER_ALTERACMOUNTAINS then
					if SubZone == REPTRACKER_GROWLESSCAVE or SubZone == REPTRACKER_GAVINSNAZE then
						local a = StormpikeGuardRepID
						RepTracker_RepValue_Display(a)
					end
				end
			end
		end
	end
	
	function ZoneInstanceData()
	
		local CurrentZone = GetRealZoneText()
		local SubZone = GetSubZoneText()
		
		GrabCurrentFactionValues()
		
		if UnitOnTaxi("player") == false then
			if CurrentZone == "Ahn'Qiraj" then
				local a = BroodofNozdormuRepID
				RepTracker_RepFactionChange_Display(a)
			end
			if CurrentZone == "Ruins of Ahn'Qiraj" then
				local a = CenarionCircleRepID
				RepTracker_RepFactionChange_Display(a)
			end
			if CurrentZone == "Moonglade" then
				local a = CenarionCircleRepID
				RepTracker_RepFactionChange_Display(a)
			end
			if CurrentZone == "Ashenvale" then
				if SubZone == "Silverwing Grove" then
					local a = SilverwingSentinelsRepID
					RepTracker_RepFactionChange_Display(a)
				end
			end
			if CurrentZone == "Arathi Highlands" then
				if SubZone == "Refuge Pointe" then
					local a = TheLeagueOfArathorRepID
					RepTracker_RepFactionChange_Display(a)
				end
			end
			if CurrentZone == "Alterac Mountains" then
				if SubZone == "The Headland" then
					local a = StormpikeGuardRepID
					RepTracker_RepFactionChange_Display(a)
				end
			end
			if CurrentZone == "Stranglethorn Vale" then
				if SubZone == "Yojamba Isle" then
					local a = ZandalarTribeRepID
					RepTracker_RepFactionChange_Display(a)
				end
			end
			if CurrentZone == "Scholomance" then
				local a = ArgentDawnRepID
				RepTracker_RepFactionChange_Display(a)
			end
			if CurrentZone == "Stratholme" then
				local a = ArgentDawnRepID
				RepTracker_RepFactionChange_Display(a)
			end
			if CurrentZone == "Silithus" then
				local a = CenarionCircleRepID
				RepTracker_RepFactionChange_Display(a)
			end
			if CurrentZone == "Zul'Gurub" then
				local a = ZandalarTribeRepID
				RepTracker_RepFactionChange_Display(a)
			end
			if CurrentZone == "Molten Core" then
				local a = HydraxianWaterlordsRepID
				RepTracker_RepFactionChange_Display(a)
			end
			if CurrentZone == "Alterac Valley" then
				if FactionIsHorde then
					local a = StormpikeGuardRepID
					RepTracker_RepFactionChange_Display(a)
				else
					local a = FrostwolfClanRepID
					RepTracker_RepFactionChange_Display(a)
				end
			end
			if CurrentZone == "Arathi Basin" then
				if FactionIsHorde then
					local a = TheDefilersRepID
					RepTracker_RepFactionChange_Display(a)
				else
					local a = TheLeagueOfArathorRepID
					RepTracker_RepFactionChange_Display(a)
				end
			end
			if CurrentZone == "Warsong Gultch" then
				if FactionIsHorde then
					local a = WarsongOutridersRepID
					RepTracker_RepFactionChange_Display(a)
				else
					local a = SilverwingSentinelsRepID
					RepTracker_RepFactionChange_Display(a)
				end
			end
			if CurrentZone == "Searing Gorge" then
				local a = ThoriumBrotherhoodRepID
				RepTracker_RepFactionChange_Display(a)
			end
			if CurrentZone == "Winterspring" then
				local a = TimbermawHoldRepID
				RepTracker_RepFactionChange_Display(a)
			end
			if CurrentZone == "Felwood" then
				local a = TimbermawHoldRepID
				RepTracker_RepFactionChange_Display(a)
			end
			if CurrentZone == "Darnassus" then
				local a = DarnassusRepID
				RepTracker_RepFactionChange_Display(a)
			end
			if CurrentZone == "Stormwind City" then
				local a = StormwindRepID
				RepTracker_RepFactionChange_Display(a)
			end
			if CurrentZone == "Ironforge" then
				if SubZone == "Hall of Arms" then
					-- Do nothing.
				elseif SubZone == "Tinker Town" then
					local a = GnomereganExilesRepId
					RepTracker_RepFactionChange_Display(a)
				else
					local a = IronforgeRepID
					RepTracker_RepFactionChange_Display(a)
				end
			end
		end
	end
	
	function GrabCurrentFactionValues()
	
		local CurrentZone = GetRealZoneText()
		
		for factionIndex = 1, GetNumFactions() do
		
			local name = GetFactionInfo(factionIndex)
			
			--Raid REPs
			if name == "Brood of Nozdormu" then
				BroodofNozdormuRepID = factionIndex
			end
			if name == "Cenarion Circle" then
				CenarionCircleRepID = factionIndex
			end
			if name == "Zandalar Tribe" then
				ZandalarTribeRepID = factionIndex
			end
			if name == "Hydraxian Waterlords" then
				HydraxianWaterlordsRepID = factionIndex
			end
			if name == "Argent Dawn" then
				ArgentDawnRepID = factionIndex
			end
			--World REPs
			if name == "Thorium Brotherhood" then
				ThoriumBrotherhoodRepID = factionIndex
			end
			if name == "Timbermaw Hold" then
				TimbermawHoldRepID = factionIndex
			end
			--PvP and Major City REPs
			if FactionIsAlliance then
				if name == "Stormpike Guard" then
					StormpikeGuardRepID = factionIndex
				end
				if name == "The League of Arathor" then
					TheLeagueOfArathorRepID = factionIndex
				end
				if name == "Silverwing Sentinels" then
					SilverwingSentinelsRepID = factionIndex
				end
				if name == "Ironforge" then
					IronforgeRepID = factionIndex
				end
				if name == "Darnassus" then
					DarnassusRepID = factionIndex
				end
				if name == "Gnomeregan Exiles" then
					GnomereganExilesRepId = factionIndex
				end
				if name == "Stormwind" then
					StormwindRepID = factionIndex
				end
			end
			if FactionIsHorde then
				if name == "The Defilers" then
					TheDefilersRepID = factionIndex
				end
				if name == "Frostwolf Clan" then
					FrostwolfClanRepID = factionIndex
				end
				if name == "Warsong Outriders" then
					WarsongOutridersRepID = factionIndex
				end
				if name == "Orgrimmar" then
					OrgrimmarRepID = factionIndex
				end
				if name == "Undercity" then
					UndercityRepID = factionIndex
				end
				if name == "Thunder Bluff" then
					ThunderBluffRepID = factionIndex
				end
				if name == "Darkspear Trolls" then
					DarkspearTrollsRepID = factionIndex
				end
			end
		end
	end
	
function RepTracker_GlobalTimerTrackerFunctionUpdate()
	RepTracker_GlobalTimerTracker = nil
end

function RepTracker_RepValue_Display(a)

	SetWatchedFactionIndex(a)
	
	local standingId, _, topValue, earnedValue = select(3,GetFactionInfo(a))

	if standingId == 0 then -- Unknown
		--Skip
	elseif standingId == 1 then -- Hated
		print("|cff67BCFF"..REPTRACKER_ANNOUNCE1.."|r "..math.floor(earnedValue+42000).."/"..math.floor(topValue+42000).." |cffFF3F40("..REPTRACKER_HATED..")|r")
	elseif standingId == 2 then -- Hostile
		print("|cff67BCFF"..REPTRACKER_ANNOUNCE1.."|r "..math.floor(earnedValue+6000).."/"..math.floor(topValue+6000).." |cffFF3F40("..REPTRACKER_HOSTILE..")|r")
	elseif standingId == 3 then -- Unfriendly
		print("|cff67BCFF"..REPTRACKER_ANNOUNCE1.."|r "..math.floor(earnedValue+3000).."/"..math.floor(topValue+3000).." |cffFF3F40("..REPTRACKER_UNFRIENDLY..")|r")
	elseif standingId == 4 then -- Neutral
		print("|cff67BCFF"..REPTRACKER_ANNOUNCE1.."|r "..math.floor(earnedValue).."/"..math.floor(topValue).." |cffFFFF00("..REPTRACKER_NEUTRAL..")|r")
	elseif standingId == 5 then -- Friendly
		print("|cff67BCFF"..REPTRACKER_ANNOUNCE1.."|r "..math.floor(earnedValue-3000).."/"..math.floor(topValue-3000).." |cff008000("..REPTRACKER_FRIENDLY..")|r")
	elseif standingId == 6 then -- Honored
		print("|cff67BCFF"..REPTRACKER_ANNOUNCE1.."|r "..math.floor(earnedValue-9000).."/"..math.floor(topValue-9000).." |cff008000("..REPTRACKER_HONORED..")|r")
	elseif standingId == 7 then -- Revered
		print("|cff67BCFF"..REPTRACKER_ANNOUNCE1.."|r "..math.floor(earnedValue-21000).."/"..math.floor(topValue-21000).." |cff008000("..REPTRACKER_REVERED..")|r")
	elseif standingId == 8 then -- Exalted
		print("|cff67BCFF"..REPTRACKER_ANNOUNCE1.."|r "..math.floor(earnedValue-42000).."/"..math.floor(topValue-42000).." |cff008000("..REPTRACKER_EXALTED..")|r")
	end
end

function RepTracker_RepFactionChange_Display(a)

	SetWatchedFactionIndex(a)

	local name, _, standingId, _, _, _, _, _, _, _, _, isWatched, _, factionID = GetFactionInfo(a)
	
	if isWatched ~= true then
		if RepTracker_GlobalTimerTracker == nil or isPlayerInBattleground_GlobalString ~= 0 then
			if standingId <= 3 then
				print("|cff67BCFF"..REPTRACKER_ANNOUNCE2.." |cffFF3F40"..name.."|r")
			elseif standingId == 4 then
				print("|cff67BCFF"..REPTRACKER_ANNOUNCE2.." |cffFFFF00"..name.."|r")
			elseif standingId >= 5 then
				print("|cff67BCFF"..REPTRACKER_ANNOUNCE2.." |cff008000"..name.."|r")
			end
			RepTracker_GlobalTimerTracker = 1
			C_Timer.After(20,RepTracker_GlobalTimerTrackerFunctionUpdate)
		else
			print(REPTRACKER_ERROR1)
		end
	end
end

function PlayerInMajorCity()
	local CurrentZone = GetRealZoneText()
	if CurrentZone == "Ironforge" or "Stormwind City" or "Darnassus" or "Thunder Bluff" or "Ogrimmar" or "The Undercity" then
		PlayerInMajorCity_GlobalString = 1
	else
		PlayerInMajorCity_GlobalString = 0
	end
end

function isPlayerInBattleground()
	local CurrentZone = GetRealZoneText()
	if CurrentZone == "Arathi Basin" or "Alterac Valley" or "Warsong Gultch" then
		isPlayerInBattleground_GlobalString = 1
		C_Timer.After(5,ZoneInstanceData)
	else
		isPlayerInBattleground_GlobalString = 0
	end
end
	--core_frame:SetScript("OnUpdate", CoreFrame_OnUpdate)
	core_frame:SetScript("OnEvent", CoreFrame_OnEvent)